Bug 1914246 - python-uvicorn fails to build with Python 3.10 due to problem in python-websockets: the *loop* parameter was removed from Lock()
Summary: python-uvicorn fails to build with Python 3.10 due to problem in python-webso...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: python-websockets
Version: 35
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Julien Enselme
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On: 2002542
Blocks: PYTHON3.10 1969166
TreeView+ depends on / blocked
 
Reported: 2021-01-08 12:47 UTC by Miro Hrončok
Modified: 2021-09-16 23:55 UTC (History)
5 users (show)

Fixed In Version: python-websockets-10.0-1.fc35
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2021-09-16 23:55:17 UTC
Type: Bug


Attachments (Terms of Use)


Links
System ID Private Priority Status Summary Last Updated
Github aaugustin websockets pull 936 0 None None None 2021-09-09 21:06:29 UTC

Description Miro Hrončok 2021-01-08 12:47:34 UTC
python-uvicorn fails to build with Python 3.10.0a4.

The tests hang, but when timeout is added, the error is:

Traceback (most recent call last):
  File "uvloop/handles/stream.pyx", line 829, in uvloop.loop.__uv_stream_on_read_impl
  File "/builddir/build/BUILD/uvicorn-0.12.2/uvicorn/protocols/http/h11_impl.py", line 162, in data_received
    self.handle_events()
  File "/builddir/build/BUILD/uvicorn-0.12.2/uvicorn/protocols/http/h11_impl.py", line 211, in handle_events
    self.handle_upgrade(event)
  File "/builddir/build/BUILD/uvicorn-0.12.2/uvicorn/protocols/http/h11_impl.py", line 288, in handle_upgrade
    protocol = self.ws_protocol_class(
  File "/builddir/build/BUILD/uvicorn-0.12.2/uvicorn/protocols/websockets/websockets_impl.py", line 57, in __init__
    super().__init__(ws_handler=self.ws_handler, ws_server=self.ws_server)
  File "/usr/lib64/python3.10/site-packages/websockets/server.py", line 103, in __init__
    super().__init__(**kwargs)
  File "/usr/lib64/python3.10/site-packages/websockets/protocol.py", line 235, in __init__
    self._drain_lock = asyncio.Lock(
  File "/usr/lib64/python3.10/asyncio/locks.py", line 77, in __init__
    super().__init__(loop=loop)
  File "/usr/lib64/python3.10/asyncio/mixins.py", line 17, in __init__
    raise TypeError(
TypeError: As of 3.10, the *loop* parameter was removed from Lock() since it is no longer necessary


This comes from /usr/lib64/python3.10/site-packages/websockets/protocol.py



For the build logs, see:
https://copr-be.cloud.fedoraproject.org/results/@python/python3.10/fedora-rawhide-x86_64/01868465-python-uvicorn/

For all our attempts to build python-uvicorn with Python 3.10, see:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/package/python-uvicorn/

Testing and mass rebuild of packages is happening in copr. You can follow these instructions to test locally in mock if your package builds with Python 3.10:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/

Let us know here if you have any questions.

Python 3.10 will be included in Fedora 35. To make that update smoother, we're building Fedora packages with early pre-releases of Python 3.10.
A build failure prevents us from testing all dependent packages (transitive [Build]Requires), so if this package is required a lot, it's important for us to get it fixed soon.
We'd appreciate help from the people who know this package best, but if you don't want to work on this now, let us know so we can try to work around it on our side.

Comment 1 Ben Cotton 2021-02-09 15:38:22 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 34 development cycle.
Changing version to 34.

Comment 2 Miro Hrončok 2021-06-04 20:14:25 UTC
This is a mass-posted update. Sorry if it is not 100% accurate to this bugzilla.


The Python 3.10 rebuild is in progress in a Koji side tag. If you manage to fix the problem, please commit the fix in the rawhide branch, but don't build the package in regular rawhide.

You can either build the package in the side tag, with:

    $ fedpkg build --target=f35-python

Or you can the build and we will eventually build it for you.

Note that the rebuild is still in progress, so not all (build) dependencies of this package might be available right away.

Thanks.

See also https://fedoraproject.org/wiki/Changes/Python3.10

If you have general questions about the rebuild, please use this mailing list thread: https://lists.fedoraproject.org/archives/list/devel@lists.fedoraproject.org/thread/G47SGOYIQLRDTWGOSLSWERZSSHXDEDH5/

Comment 3 Miro Hrončok 2021-06-07 22:59:04 UTC
The f35-python side tag has been merged to Rawhide. From now on, build as you would normally build.

Comment 4 Ben Cotton 2021-08-10 12:50:07 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 35 development cycle.
Changing version to 35.

Comment 5 Miro Hrončok 2021-09-09 21:06:29 UTC
Could this be fixed, please?


Upstream fixed it in https://github.com/aaugustin/websockets/pull/936 released as 10.0. Thnaks.

Comment 7 Fedora Update System 2021-09-10 14:08:48 UTC
FEDORA-2021-389bdf883b has been pushed to the Fedora 36 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 8 Fedora Update System 2021-09-10 15:01:14 UTC
FEDORA-2021-55adef54f6 has been submitted as an update to Fedora 35. https://bodhi.fedoraproject.org/updates/FEDORA-2021-55adef54f6

Comment 9 Fedora Update System 2021-09-10 22:12:19 UTC
FEDORA-2021-55adef54f6 has been pushed to the Fedora 35 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf upgrade --enablerepo=updates-testing --advisory=FEDORA-2021-55adef54f6`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2021-55adef54f6

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 10 Fedora Update System 2021-09-12 08:12:02 UTC
FEDORA-2021-55adef54f6 has been submitted as an update to Fedora 35. https://bodhi.fedoraproject.org/updates/FEDORA-2021-55adef54f6

Comment 11 Fedora Update System 2021-09-12 18:08:50 UTC
FEDORA-2021-55adef54f6 has been pushed to the Fedora 35 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf upgrade --enablerepo=updates-testing --advisory=FEDORA-2021-55adef54f6`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2021-55adef54f6

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 12 Fedora Update System 2021-09-16 23:55:17 UTC
FEDORA-2021-55adef54f6 has been pushed to the Fedora 35 stable repository.
If problem still persists, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.